Index: branches/HivePerformance/sources/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionProblemEvaluator.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionProblemEvaluator.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Problems.TestFunctions/3.3/Interfaces/ISingleObjectiveTestFunctionProblemEvaluator.cs	(revision 9444)
@@ -39,5 +39,5 @@
 
     double Evaluate2D(double x, double y);
-    double EvaluateFunction(RealVector point);
+    double Evaluate(RealVector point);
     RealVector GetBestKnownSolution(int dimension);
   }
Index: branches/HivePerformance/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/MultinormalAdditiveMoveEvaluator.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/MultinormalAdditiveMoveEvaluator.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/MultinormalAdditiveMoveEvaluator.cs	(revision 9444)
@@ -55,5 +55,5 @@
       var eval = EvaluatorParameter.ActualValue as MultinormalEvaluator;
       if (eval != null)
-        return eval.EvaluateFunction(wrapper);
+        return eval.Evaluate(wrapper);
       throw new InvalidOperationException("evaluator is not a multinormal evaluator");
     }
Index: branches/HivePerformance/sources/HeuristicLab.Problems.TravelingSalesman/3.3/SimilarityCalculators/TSPSimilarityCalculator.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Problems.TravelingSalesman/3.3/SimilarityCalculators/TSPSimilarityCalculator.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Problems.TravelingSalesman/3.3/SimilarityCalculators/TSPSimilarityCalculator.cs	(revision 9444)
@@ -73,11 +73,11 @@
 
     private static double CalculateRelativeDirected(Permutation left, Permutation right) {
-      int[] edges = new int[right.Length];
-      for (int i = 0; i < right.Length; i++)
-        edges[right[i]] = right[(i + 1) % right.Length];
+      int[] edgesR = CalculateEdgesVector(right);
+      int[] edgesL = CalculateEdgesVector(left);
 
       double similarity = 0.0;
-      for (int i = 0; i < left.Length; i++)
-        if (left[(i + 1) % left.Length] == edges[left[i]]) similarity++;
+      for (int i = 0; i < left.Length; i++) {
+        if (edgesL[i] == edgesR[i]) similarity++;
+      }
 
       return similarity / left.Length;
@@ -85,18 +85,23 @@
 
     private static double CalculateRelativeUndirected(Permutation left, Permutation right) {
-      int[,] edges = new int[right.Length, 2];
-      for (int i = 0; i < right.Length; i++) {
-        edges[right[i], 0] = right[(i + 1) % right.Length];
-        edges[right[i], 1] = right[(i - 1 + right.Length) % right.Length];
-      }
+      int[] edgesR = CalculateEdgesVector(right);
+      int[] edgesL = CalculateEdgesVector(left);
 
       double similarity = 0.0;
       for (int i = 0; i < left.Length; i++) {
-        int targetCity = left[(i + 1) % left.Length];
-        if (targetCity == edges[left[i], 0] || targetCity == edges[left[i], 1])
+        if ((edgesL[i] == edgesR[i]) || (edgesL[edgesR[i]] == i))
           similarity++;
       }
 
       return similarity / left.Length;
+    }
+
+    private static int[] CalculateEdgesVector(Permutation permutation) {
+      // transform path representation into adjacency representation
+      int[] edgesVector = new int[permutation.Length];
+      for (int i = 0; i < permutation.Length - 1; i++)
+        edgesVector[permutation[i]] = permutation[i + 1];
+      edgesVector[permutation[permutation.Length - 1]] = permutation[0];
+      return edgesVector;
     }
 
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Convert.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Convert.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/Convert.cs	(revision 9444)
@@ -67,5 +67,4 @@
         target.LastHeartbeat = source.LastHeartbeat;
         target.State = Convert.ToEntity(source.State);
-        if (target.StateLogs == null) target.StateLogs = new EntitySet<DB.StateLog>();
         foreach (DT.StateLog sl in source.StateLog.Where(x => x.Id == Guid.Empty)) {
           target.StateLogs.Add(Convert.ToEntity(sl));
Index: branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Services.Hive/3.3/HiveDao.cs	(revision 9444)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.Data.Linq;
 using System.Linq;
 using System.Linq.Expressions;
@@ -120,4 +121,8 @@
     public void UpdateTaskAndStateLogs(DT.Task dto) {
       using (var db = CreateContext()) {
+        DataLoadOptions dlo = new DataLoadOptions();
+        dlo.LoadWith<Task>(x => x.StateLogs);
+        db.LoadOptions = dlo;
+
         var entity = db.Tasks.FirstOrDefault(x => x.TaskId == dto.Id);
         if (entity == null) db.Tasks.InsertOnSubmit(DT.Convert.ToEntity(dto));
@@ -205,9 +210,4 @@
           DateTime = DateTime.Now
         });
-        db.SubmitChanges();
-      }
-
-      using (var db = CreateContext()) {
-        db.DeferredLoadingEnabled = false;
 
         var task = db.Tasks.SingleOrDefault(x => x.TaskId == taskId);
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Grammars.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Grammars.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Grammars.cs	(revision 9444)
@@ -20,197 +20,10 @@
 #endregion
 
-using System.Collections.Generic;
 using System.Linq;
-using HeuristicLab.Common;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.DataAnalysis.Symbolic;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
   public static class Grammars {
-    [StorableClass]
-    private class Addition : Symbol {
-      private const int minimumArity = 1;
-      private const int maximumArity = byte.MaxValue;
-
-      public override int MinimumArity {
-        get { return minimumArity; }
-      }
-      public override int MaximumArity {
-        get { return maximumArity; }
-      }
-
-      [StorableConstructor]
-      protected Addition(bool deserializing) : base(deserializing) { }
-      protected Addition(Addition original, Cloner cloner) : base(original, cloner) { }
-      public Addition() : base("Addition", "") { }
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new Addition(this, cloner);
-      }
-    }
-
-    [StorableClass]
-    private class Subtraction : Symbol {
-      private const int minimumArity = 1;
-      private const int maximumArity = byte.MaxValue;
-
-      public override int MinimumArity {
-        get { return minimumArity; }
-      }
-      public override int MaximumArity {
-        get { return maximumArity; }
-      }
-
-      [StorableConstructor]
-      protected Subtraction(bool deserializing) : base(deserializing) { }
-      protected Subtraction(Subtraction original, Cloner cloner) : base(original, cloner) { }
-      public Subtraction() : base("Subtraction", "") { }
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new Subtraction(this, cloner);
-      }
-    }
-
-    [StorableClass]
-    private class Multiplication : Symbol {
-      private const int minimumArity = 1;
-      private const int maximumArity = byte.MaxValue;
-
-      public override int MinimumArity {
-        get { return minimumArity; }
-      }
-      public override int MaximumArity {
-        get { return maximumArity; }
-      }
-
-      [StorableConstructor]
-      protected Multiplication(bool deserializing) : base(deserializing) { }
-      protected Multiplication(Multiplication original, Cloner cloner) : base(original, cloner) { }
-      public Multiplication() : base("Multiplication", "") { }
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new Multiplication(this, cloner);
-      }
-    }
-
-    [StorableClass]
-    private class Division : Symbol {
-      private const int minimumArity = 1;
-      private const int maximumArity = byte.MaxValue;
-
-      public override int MinimumArity {
-        get { return minimumArity; }
-      }
-      public override int MaximumArity {
-        get { return maximumArity; }
-      }
-
-      [StorableConstructor]
-      protected Division(bool deserializing) : base(deserializing) { }
-      protected Division(Division original, Cloner cloner) : base(original, cloner) { }
-      public Division() : base("Division", "") { }
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new Division(this, cloner);
-      }
-    }
-
-    [StorableClass]
-    private class Terminal : Symbol {
-      private const int minimumArity = 0;
-      private const int maximumArity = 0;
-
-      public override int MinimumArity {
-        get { return minimumArity; }
-      }
-      public override int MaximumArity {
-        get { return maximumArity; }
-      }
-
-      [StorableConstructor]
-      protected Terminal(bool deserializing) : base(deserializing) { }
-      protected Terminal(Terminal original, Cloner cloner) : base(original, cloner) { }
-      public Terminal() : base("Terminal", "") { }
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new Terminal(this, cloner);
-      }
-
-      public override ISymbolicExpressionTreeNode CreateTreeNode() {
-        return new TerminalNode(this);
-      }
-    }
-
-    [StorableClass]
-    private class TerminalNode : SymbolicExpressionTreeTerminalNode {
-      public override bool HasLocalParameters { get { return true; } }
-      private double value;
-      protected TerminalNode(TerminalNode original, Cloner cloner)
-        : base(original, cloner) {
-        this.value = original.value;
-      }
-      [StorableConstructor]
-      protected TerminalNode(bool deserializing) : base(deserializing) { }
-      public TerminalNode(Terminal symbol) : base(symbol) { }
-
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new TerminalNode(this, cloner);
-      }
-      public override void ResetLocalParameters(Core.IRandom random) {
-        base.ResetLocalParameters(random);
-        value = random.NextDouble();
-      }
-      public override void ShakeLocalParameters(Core.IRandom random, double shakingFactor) {
-        base.ShakeLocalParameters(random, shakingFactor);
-        value = random.NextDouble();
-      }
-      public override string ToString() {
-        return value.ToString("E4");
-      }
-    }
-
-    [StorableClass]
-    private class SimpleArithmeticGrammar : SymbolicExpressionGrammar {
-      [StorableConstructor]
-      protected SimpleArithmeticGrammar(bool deserializing) : base(deserializing) { }
-      protected SimpleArithmeticGrammar(SimpleArithmeticGrammar original, Cloner cloner) : base(original, cloner) { }
-      public SimpleArithmeticGrammar()
-        : base("Grammar for unit tests", "") {
-        Initialize();
-      }
-
-      public override IDeepCloneable Clone(Cloner cloner) {
-        return new SimpleArithmeticGrammar(this, cloner);
-      }
-
-      private void Initialize() {
-        var add = new Addition();
-        var sub = new Subtraction();
-        var mul = new Multiplication();
-        var div = new Division();
-        div.InitialFrequency = 0.0; // disable division symbol
-        var terminal = new Terminal();
-
-        var allSymbols = new List<Symbol>() { add, sub, mul, div, terminal };
-        var functionSymbols = new List<Symbol>() { add, sub, mul, div };
-        foreach (var symb in allSymbols)
-          AddSymbol(symb);
-
-        foreach (var funSymb in functionSymbols) {
-          SetSubtreeCount(funSymb, 1, 3);
-        }
-        SetSubtreeCount(terminal, 0, 0);
-
-        // allow each symbol as child of the start symbol
-        foreach (var symb in allSymbols) {
-          AddAllowedChildSymbol(StartSymbol, symb);
-          AddAllowedChildSymbol(DefunSymbol, symb);
-        }
-
-        // allow each symbol as child of every other symbol (except for terminals that have maxSubtreeCount == 0)
-        foreach (var parent in functionSymbols) {
-          foreach (var child in allSymbols) {
-            AddAllowedChildSymbol(parent, child);
-          }
-        }
-      }
-    }
-
     public static ISymbolicExpressionGrammar CreateSimpleArithmeticGrammar() {
       var g = new TypeCoherentExpressionGrammar();
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/AckleyEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/AckleyEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/AckleyEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BealeEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BealeEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BealeEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BoothEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BoothEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/BoothEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/GriewankEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/GriewankEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/GriewankEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/LevyEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/LevyEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/LevyEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/MatyasEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/MatyasEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/MatyasEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RastriginEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RastriginEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RastriginEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RosenbrockEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RosenbrockEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/RosenbrockEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SphereEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SphereEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SphereEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SumSquaresEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SumSquaresEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/SumSquaresEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/ZakharovEvaluatorTest.cs
===================================================================
--- branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/ZakharovEvaluatorTest.cs	(revision 9434)
+++ branches/HivePerformance/sources/HeuristicLab.Tests/HeuristicLab.Problems.TestFunctions-3.3/ZakharovEvaluatorTest.cs	(revision 9444)
@@ -92,5 +92,5 @@
       for (int dimension = target.MinimumProblemSize; dimension <= System.Math.Min(10, target.MaximumProblemSize); dimension++) {
         point = target.GetBestKnownSolution(dimension);
-        actual = target.EvaluateFunction(point);
+        actual = target.Evaluate(point);
         Assert.AreEqual(expected, actual);
       }
Index: branches/HivePerformance/sources/PreBuildEvent.cmd
===================================================================
--- branches/HivePerformance/sources/PreBuildEvent.cmd	(revision 9434)
+++ branches/HivePerformance/sources/PreBuildEvent.cmd	(revision 9444)
@@ -1,2 +1,11 @@
 IF EXIST "%ProjectDir%\Properties\AssemblyInfo.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
+IF %ERRORLEVEL% NEQ 0 GOTO Error_Handling
 IF EXIST "%ProjectDir%\Plugin.cs.frame" SubWCRev "%ProjectDir%\" "%ProjectDir%\Plugin.cs.frame" "%ProjectDir%\Plugin.cs"
+IF %ERRORLEVEL% NEQ 0 GOTO Error_Handling
+GOTO Done
+
+:Error_Handling
+ECHO There was an error while running subwcrev. Please verify that the *.cs.frame files have been correctly converted to *.cs files, otherwise HeuristicLab won't build. 
+exit 0
+
+:Done
